﻿
#region SILENT DEVELOPMENTS generated code

using System;
using System.Configuration;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace SilDev
{
    class Crypt
    {
        #region BaseExtrem

        private static int GetBaseExtremBitValue(int _inputBit)
        {
            int output = 0;
            switch (_inputBit)
            {
                case 64:
                    output = 1;
                    break;
                case 96:
                    output = 2;
                    break;
                case 128:
                    output = 3;
                    break;
                case 320:
                    output = 6;
                    break;
                case 768:
                    output = 9;
                    break;
                case 1024:
                    output = 10;
                    break;
                case 4400:
                    output = 15;
                    break;
                case 18608:
                    output = 20;
                    break;
                case 44128:
                    output = 23;
                    break;
                case 186016:
                    output = 28;
                    break;
            }
            return output;
        }

        public static string[] EncryptToBaseExtremeArray(string _inputText, int _inputNum)
        {
            string crypt = EncryptToBaseExtreme(_inputText, _inputNum);
            StringBuilder output = new StringBuilder();
            Random random = new Random();
            int num = random.Next(2, 6);
            for (int i = 0; i < crypt.Length; i++)
            {
                if (i > 0 && i % num == 0)
                {
                    num = random.Next(2, 6);
                    output.AppendLine();
                    output.Append(crypt[i]);
                }
                else
                    output.Append(crypt[i]);
            }
            return output.ToString().Replace("\r", string.Empty).Split('\n');
        }

        public static string EncryptToBaseExtreme(string _inputText, int _inputBit)
        {
            StringBuilder output = new StringBuilder(EncryptToBase64(_inputText));
            for (int i = 0; i < GetBaseExtremBitValue(_inputBit); i++)
            {
                output = output.Replace(output.ToString(), ReverseString(output.ToString()));
                output = output.Replace(output.ToString(), EncryptToBase64(output.ToString()));
            }
            return output.ToString();
        }

        public static string EncryptToBaseExtreme(string _inputText)
        {
            StringBuilder output = new StringBuilder(EncryptToBase64(_inputText));
            output = output.Replace(output.ToString(), ReverseString(output.ToString()));
            output = output.Replace(output.ToString(), EncryptToBase64(output.ToString()));
            return output.ToString();
        }

        public static string DecryptFromBaseExtremeArray(string[] _inputHashArray, int _inputBit)
        {
            string output = string.Concat(_inputHashArray);
            return DecryptFromBaseExtreme(output, _inputBit);
        }

        public static string DecryptFromBaseExtreme(string _inputHash, int _inputBit)
        {
            string output = DecryptFromBase64(_inputHash);
            for (int i = 0; i < GetBaseExtremBitValue(_inputBit); i++)
            {
                output = ReverseString(output);
                output = DecryptFromBase64(output);
            }
            return output;
        }

        public static string DecryptFromBaseExtreme(string _inputHash)
        {
            string output = DecryptFromBase64(_inputHash);
            output = ReverseString(output);
            output = DecryptFromBase64(output);
            return output;
        }

        #endregion

        #region Base64

        public static string EncryptToBase64(string _inputText)
        {
            byte[] output = Encoding.UTF8.GetBytes(_inputText);
            return Convert.ToBase64String(output);
        }

        public static string DecryptFromBase64(string _inputHash)
        {
            byte[] output = Convert.FromBase64String(_inputHash);
            return Encoding.UTF8.GetString(output);
        }

        public static string EncryptImageToBase64(System.Drawing.Image _inputImage, System.Drawing.Imaging.ImageFormat _inputFormat)
        {
            string output = string.Empty;
            using (MemoryStream memoryStream = new MemoryStream())
            {
                _inputImage.Save(memoryStream, _inputFormat);
                output = Convert.ToBase64String(memoryStream.ToArray());
                memoryStream.Dispose();
            }
            return output;
        }

        public static System.Drawing.Image DecryptImageFromBase64(string _inputHash)
        {
            System.Drawing.Image output;
            using (MemoryStream memoryStream = new MemoryStream(Convert.FromBase64String(_inputHash)))
            {
                output = System.Drawing.Image.FromStream(memoryStream);
                memoryStream.Dispose();
            }
            return output;
        }

        #endregion

        #region Message-Digest Algorithm 5

        public static string EncryptFileToMD5(string _inputFilePath)
        {
            string output = string.Empty;
            if (File.Exists(_inputFilePath))
            {
                using (FileStream fileStream = File.OpenRead(_inputFilePath))
                {
                    MD5 crypt = new MD5CryptoServiceProvider();
                    byte[] encode = crypt.ComputeHash(fileStream);
                    fileStream.Dispose();
                    output = BitConverter.ToString(encode);
                    output = output.Replace("-", string.Empty).ToLower();
                }
            }
            return output;
        }

        public static string EncryptToMD5(FileInfo _inputFileInfo)
        {
            return EncryptFileToMD5(_inputFileInfo.FullName);
        }

        public static string EncryptToMD5(string _inputText)
        {
            string output = string.Empty;
            using (var create = MD5.Create())
            {
                var encode = Encoding.UTF8.GetBytes(_inputText);
                var hashedDataBytes = create.ComputeHash(encode);
                output = ByteArrayToString(hashedDataBytes);
            }
            return output;
        }

        public static bool CompareMD5(string _checksumA, string _checksumB)
        {
            return (_checksumA.Length == 32 && _checksumB.Length == 32) ? (_checksumA.ToLower() == _checksumB.ToLower()) : false;
        }

        #endregion

        #region Secure Hash Algorithm

        public static string EncryptFileToSHA(string _inputFilePath)
        {
            string output = string.Empty;
            if (File.Exists(_inputFilePath))
            {
                using (FileStream fileStream = File.OpenRead(_inputFilePath))
                {
                    SHA1 crypt = new SHA1CryptoServiceProvider();
                    byte[] encode = crypt.ComputeHash(fileStream);
                    fileStream.Dispose();
                    output = BitConverter.ToString(encode);
                    output = output.Replace("-", string.Empty).ToLower();
                }
            }
            return output;
        }

        public static string EncryptToSHA(FileInfo _inputFileInfo)
        {
            return EncryptFileToSHA(_inputFileInfo.FullName);
        }

        public static string EncryptToSHA(string _inputText, string _inputMethod)
        {
            string output = string.Empty;
            switch (_inputMethod)
            {
                case "256":
                    output = EncryptToSHA256(_inputText);
                    break;
                case "384":
                    output = EncryptToSHA384(_inputText);
                    break;
                case "512":
                    output = EncryptToSHA512(_inputText);
                    break;
                default:
                    output = EncryptToSHA(_inputText);
                    break;
            }
            return output;
        }

        public static string EncryptToSHA(string _inputText)
        {
            string output = string.Empty;
            using (var create = SHA1.Create())
            {
                var encode = Encoding.UTF8.GetBytes(_inputText);
                var hashedDataBytes = create.ComputeHash(encode);
                output = ByteArrayToString(hashedDataBytes);
            }
            return output;
        }

        public static string EncryptFileToSHA256(string _inputFilePath)
        {
            string output = string.Empty;
            if (File.Exists(_inputFilePath))
            {
                using (FileStream fileStream = File.OpenRead(_inputFilePath))
                {
                    SHA256 crypt = new SHA256CryptoServiceProvider();
                    byte[] encode = crypt.ComputeHash(fileStream);
                    fileStream.Dispose();
                    output = BitConverter.ToString(encode);
                    output = output.Replace("-", string.Empty).ToLower();
                }
            }
            return output;
        }

        public static string EncryptToSHA256(FileInfo _inputFileInfo)
        {
            return EncryptFileToSHA256(_inputFileInfo.FullName);
        }

        public static string EncryptToSHA256(string _inputText)
        {
            string output = string.Empty;
            using (var create = SHA256.Create())
            {
                var encode = Encoding.UTF8.GetBytes(_inputText);
                var hashedDataBytes = create.ComputeHash(encode);
                output = ByteArrayToString(hashedDataBytes);
            }
            return output;
        }

        public static string EncryptFileToSHA384(string _inputFilePath)
        {
            string output = string.Empty;
            if (File.Exists(_inputFilePath))
            {
                using (FileStream fileStream = File.OpenRead(_inputFilePath))
                {
                    SHA384 crypt = new SHA384CryptoServiceProvider();
                    byte[] encode = crypt.ComputeHash(fileStream);
                    fileStream.Dispose();
                    output = BitConverter.ToString(encode);
                    output = output.Replace("-", string.Empty).ToLower();
                }
            }
            return output;
        }

        public static string EncryptToSHA384(FileInfo _inputFileInfo)
        {
            return EncryptFileToSHA384(_inputFileInfo.FullName);
        }

        public static string EncryptToSHA384(string _inputText)
        {
            string output = string.Empty;
            using (var create = SHA384.Create())
            {
                var encode = Encoding.UTF8.GetBytes(_inputText);
                var hashedDataBytes = create.ComputeHash(encode);
                output = ByteArrayToString(hashedDataBytes);
            }
            return output;
        }

        public static string EncryptFileToSHA512(string _inputFilePath)
        {
            string output = string.Empty;
            if (File.Exists(_inputFilePath))
            {
                using (FileStream fileStream = File.OpenRead(_inputFilePath))
                {
                    SHA512 crypt = new SHA512CryptoServiceProvider();
                    byte[] encode = crypt.ComputeHash(fileStream);
                    fileStream.Dispose();
                    output = BitConverter.ToString(encode);
                    output = output.Replace("-", string.Empty).ToLower();
                }
            }
            return output;
        }

        public static string EncryptToSHA512(FileInfo _inputFileInfo)
        {
            return EncryptFileToSHA512(_inputFileInfo.FullName);
        }

        public static string EncryptToSHA512(string _inputText)
        {
            string output = string.Empty;
            using (var create = SHA512.Create())
            {
                var encode = Encoding.UTF8.GetBytes(_inputText);
                var hashedDataBytes = create.ComputeHash(encode);
                output = ByteArrayToString(hashedDataBytes);
            }
            return output;
        }

        #endregion
        
        public static string ConvertToHex(string _input)
        {
            UTF8Encoding encode = new UTF8Encoding();
            string convert = ByteArrayToString(encode.GetBytes(_input));
            StringBuilder output = new StringBuilder();
            for (int i = 0; i < convert.Length; i++)
            {
                if (i > 0 && i % 2 == 0)
                    output.Append(' ');

                output.Append(convert[i]);
            }
            return output.ToString();
        }

        public static string ReconvertFromHex(string _input)
        {
            string filter = _input.Replace(" ", string.Empty);
            byte[] raw = new byte[filter.Length / 2];
            for (int i = 0; i < raw.Length; i++)
                raw[i] = Convert.ToByte(filter.Substring(i * 2, 2), 16);

            return Encoding.UTF8.GetString(raw);
        }

        private static string ReverseString(string _input)
        {
            StringBuilder output = new StringBuilder(string.Empty);
            for (int i = (_input.Length - 1); i >= 0; i--)
                output.Append(_input[i]);

            return output.ToString();
        }

        private static string ByteArrayToString(byte[] _inputArray)
        {
            StringBuilder output = new StringBuilder(string.Empty);
            foreach (var o in _inputArray)
                output.Append(o.ToString("x2"));

            return output.ToString();
        }
    }
}

#endregion
