﻿
#region SILENT DEVELOPMENTS generated code

#define irrKlang

using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;

namespace SilDev
{
    #region Windows Media Libary

    #if !irrKlang

    class WindowsMedia
    {
        private static readonly string _alias = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name.Replace(" ", string.Empty);

        [DllImport("winmm.dll")]
        private static extern long mciSendString(string _strCommand, StringBuilder _strReturn, Int32 _iReturnLength, IntPtr _hwndCallback);

        [DllImport("winmm.dll")]
        private static extern long PlaySound(byte[] _data, IntPtr _hMod, UInt32 _dwFlags);

        [DllImport("winmm.dll")]
        public static extern int waveOutGetVolume(IntPtr _hwo, out uint _dwVolume);

        [DllImport("winmm.dll")]
        public static extern int waveOutSetVolume(IntPtr _hwo, uint _dwVolume);

        private static string sndStatus()
        {
            StringBuilder Buffer = new StringBuilder(128);
            mciSendString("status " + _alias + " mode", Buffer, Buffer.Capacity, IntPtr.Zero);
            return Buffer.ToString();
        }

        private static void sndOpen(string _file)
        {
            if (sndStatus() != string.Empty)
                sndClose();

            string Command = "open \"" + _file + "\" alias " + _alias;
            mciSendString(Command, null, 0, IntPtr.Zero);
        }

        private static void sndClose()
        {
            string Command = "close " + _alias;
            mciSendString(Command, null, 0, IntPtr.Zero);
        }

        private static void sndPlay(bool _loop)
        {
            string Command = "play " + _alias + (_loop ? " repeat" : string.Empty);
            mciSendString(Command, null, 0, IntPtr.Zero);
        }

        private static void sndPlay()
        {
            string Command = "play " + _alias;
            mciSendString(Command, null, 0, IntPtr.Zero);
        }

        private static int getSoundVolume()
        {
            uint CurrVol = 0;
            waveOutGetVolume(IntPtr.Zero, out CurrVol);
            ushort CalcVol = (ushort)(CurrVol & 0x0000ffff);
            return (CalcVol / (ushort.MaxValue / 10)) * 10;
        }

        private static void setSoundVolume(int _value)
        {
            int newVolume = ((ushort.MaxValue / 10) * ((_value < 0 || _value > 100) ? 100 : _value / 10));
            uint newVolumeAllChannels = (((uint)newVolume & 0x0000ffff) | ((uint)newVolume << 16));
            waveOutSetVolume(IntPtr.Zero, newVolumeAllChannels);
        }

        public static void Play(string _file, int _volume, bool _loop)
        {
            if (File.Exists(_file))
            {
                if (getSoundVolume() != _volume)
                    setSoundVolume(_volume);

                sndOpen(_file);
                sndPlay(_loop);
            }
        }

        public static void Play(string _file, int _volume)
        {
            if (File.Exists(_file))
            {
                if (getSoundVolume() != _volume)
                    setSoundVolume(_volume);

                sndOpen(_file);
                sndPlay();
            }
        }

        public static void Play(string _file, bool _loop)
        {
            if (File.Exists(_file))
            {
                if (getSoundVolume() < 100)
                    setSoundVolume(100);

                sndOpen(_file);
                sndPlay(_loop);
            }
        }

        public static void Stop()
        {
            sndClose();
        }
    }
    
    #endif

    #endregion

    #region irrKlang Libary

    #if irrKlang

    class IrrKlangLib
    {
        public static bool MusicIsRunning = false;

        [DllImport("winmm.dll")]
        public static extern int waveOutGetVolume(IntPtr _hwo, out uint _dwVolume);

        [DllImport("winmm.dll")]
        public static extern int waveOutSetVolume(IntPtr _hwo, uint _dwVolume);

        private static int getSoundVolume()
        {
            uint CurrVol = 0;
            waveOutGetVolume(IntPtr.Zero, out CurrVol);
            ushort CalcVol = (ushort)(CurrVol & 0x0000ffff);
            return (CalcVol / (ushort.MaxValue / 10)) * 10;
        }

        private static void setSoundVolume(int _value)
        {
            int newVolume = ((ushort.MaxValue / 10) * ((_value < 0 || _value > 100) ? 100 : _value / 10));
            uint newVolumeAllChannels = (((uint)newVolume & 0x0000ffff) | ((uint)newVolume << 16));
            waveOutSetVolume(IntPtr.Zero, newVolumeAllChannels);
        }

        protected static IrrKlang.ISoundEngine irrKlangEngine = new IrrKlang.ISoundEngine();
        protected static IrrKlang.ISound currentlyPlayingSound;

        public static void Play(string _file, bool _loop, int _vol)
        {
            if (File.Exists(_file))
            {
                if (getSoundVolume() != _vol)
                    setSoundVolume(_vol);

                Stop();
                currentlyPlayingSound = irrKlangEngine.Play2D(_file, _loop);
                currentlyPlayingSound.Volume = 1F;
                MusicIsRunning = true;
            }
        }

        public static void Play(string _file, bool _loop)
        {
            if (File.Exists(_file))
            {
                if (getSoundVolume() != 100)
                    setSoundVolume(100);

                Stop();
                currentlyPlayingSound = irrKlangEngine.Play2D(_file, _loop);
                currentlyPlayingSound.Volume = 1F;
                MusicIsRunning = true;
            }
        }

        public static void Play(string _file, int _vol)
        {
            if (File.Exists(_file))
            {
                if (getSoundVolume() != _vol)
                    setSoundVolume(_vol);

                Stop();
                currentlyPlayingSound = irrKlangEngine.Play2D(_file, false);
                currentlyPlayingSound.Volume = 1F;
                MusicIsRunning = true;
            }
        }

        public static void Play(string _file)
        {
            if (File.Exists(_file))
            {
                if (getSoundVolume() != 100)
                    setSoundVolume(100);

                irrKlangEngine = new IrrKlang.ISoundEngine();
                Stop();
                currentlyPlayingSound = irrKlangEngine.Play2D(_file, false);
                currentlyPlayingSound.Volume = 1F;
                MusicIsRunning = true;
            }
        }

        public static void Stop()
        {
            if (currentlyPlayingSound != null)
            {
                currentlyPlayingSound.Stop();
                MusicIsRunning = false;
            }
        }
    }

    #endif

    #endregion
}

#endregion
