﻿using System;
using System.IO;
using System.Windows.Forms;

namespace CoD2SM
{
    static class Program
    {
        [STAThread]
        static void Main()
        {
            string[] neededDirs = new string[]
            {
                Path.Combine(Application.StartupPath, "main\\maps\\mp"),
                Path.Combine(Application.StartupPath, "main\\images"),
                Path.Combine(Application.StartupPath, "main\\materials")
            };
            if (Directory.Exists(neededDirs[0]) && Directory.Exists(neededDirs[1]) && Directory.Exists(neededDirs[2]))
            {
                try
                {
                    string testFilePath = Path.Combine(Application.StartupPath, "CoD2MapSorter.dat");
                    StreamWriter elevationTest = File.CreateText(testFilePath);
                    elevationTest.Write("TEST");
                    elevationTest.Close();
                    if (File.Exists(testFilePath))
                        File.Delete(testFilePath);
                }
                catch
                {
                    SilDev.Elevation.RestartAsAdministrator();
                }
                SilDev.Source.LoadAssemblies();
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                Application.Run(new MainForm());
            }
            else
                MessageBox.Show("To use this tool make sure that the following folders exist:\n\n\\main\\maps\\mp\n\\main\\images\n\\main\\materials", "Info", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
        }
    }
}
